using IceCreamShopContracts.BindingModels;
using IceCreamShopContracts.SearchModels;
using IceCreamShopContracts.StoragesContracts;
using IceCreamShopContracts.ViewModels;
using IceCreamShopFileImplement.Models;

namespace IceCreamShopFileImplement.Implements
{
    public class OrderStorage : IOrderStorage
    {
        private readonly DataFileSingleton source;

        public OrderStorage()
        {
            source = DataFileSingleton.GetInstance();
        }

        public List<OrderViewModel> GetFullList()
        {
            return source.Orders
                    .Select(x => AddInfo(x.GetViewModel))
                    .ToList();
        }

        public List<OrderViewModel> GetFilteredList(OrderSearchModel model)
        {
            if (model.Id.HasValue)
            {
                return source.Orders
                              .Where(x => x.Id == model.Id)
                              .Select(x => AddInfo(x.GetViewModel))
                              .ToList();
            }
            else if (model.DateFrom.HasValue && model.DateTo.HasValue)
            {
                return source.Orders
                              .Where(x => x.DateCreate >= model.DateFrom && x.DateCreate <= model.DateTo)
                              .Select(x => AddInfo(x.GetViewModel))
                              .ToList();
            }
            else if (model.ClientId.HasValue)
            {
                return source.Orders
                              .Where(x => x.ClientId == model.ClientId)
                              .Select(x => AddInfo(x.GetViewModel))
                              .ToList();
            }
            return new();
        }
        
        public OrderViewModel? GetElement(OrderSearchModel model)
        {
            if (!model.Id.HasValue)
            {
                return null;
            }
            var order = source.Orders.FirstOrDefault(x => x.Id == model.Id);
            if (order == null)
            {
                return null;
            }
            return AddInfo(order.GetViewModel);
        }

        public OrderViewModel? Insert(OrderBindingModel model)
        {
            model.Id = source.Orders.Count > 0 ? source.Orders.Max(x => x.Id) + 1 : 1;
            var newOrder = Order.Create(model);
            if (newOrder == null)
            {
                return null;
            }
            source.Orders.Add(newOrder);
            source.SaveOrders();
            return AddInfo(newOrder.GetViewModel);
        }

        public OrderViewModel? Update(OrderBindingModel model)
        {
            var order = source.Orders.FirstOrDefault(x => x.Id == model.Id);
            if (order == null)
            {
                return null;
            }
            order.Update(model);
            source.SaveOrders();
            return AddInfo(order.GetViewModel);
        }

        public OrderViewModel? Delete(OrderBindingModel model)
        {
            var element = source.Orders.FirstOrDefault(x => x.Id == model.Id);
            if (element != null)
            {
                source.Orders.Remove(element);
                source.SaveOrders();
                return AddInfo(element.GetViewModel);
            }
            return null;
        }

        private OrderViewModel AddInfo(OrderViewModel model)
        {
            var selectedIceCream = source.IceCreams.FirstOrDefault(x => x.Id == model.IceCreamId);
            model.IceCreamName = selectedIceCream?.IceCreamName ?? string.Empty;
            var selectedClient = source.Clients.FirstOrDefault(x => x.Id == model.ClientId);
            model.ClientFIO = selectedClient?.ClientFIO ?? string.Empty;
            return model;
        }
    }
}
